/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Kret
Version : 
Date    : 2017-05-05
Author  : KM
Company : No Company
Comments: wersja docelowa z wykorzystaniem maszyny stanw


Chip type               : ATtiny43U
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 64
*****************************************************/

#include <tiny43u.h>
#include <delay.h>

#define WIBR PORTB.1
#define LIGHT_SENSOR 0
//poziomy jasnoci - musi by histereza
#define DAY 64
#define NIGHT 128
#define ADC_VREF_TYPE 0x40

bit timer0_ctc;
char light, work_delay, work_cycles;
enum state{night, morning, day} device_state;

// Timer 0 output compare B interrupt service routine
interrupt [TIM0_COMPA] void timer0_compa_isr(void)
{
    //period 250mS (1MHz/1024/244)
    timer0_ctc=1;
}

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
    ADMUX=(adc_input & 0x03) | ADC_VREF_TYPE;
    // Delay needed for the stabilization of the ADC input voltage
    delay_us(10);
    // Start the AD conversion
    ADCSRA|=0x40;
    // Wait for the AD conversion to complete
    while ((ADCSRA & 0x10)==0);
    ADCSRA|=0x10;
    return ADCH;
}

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 8   (1MHz clock)
#pragma optsize-
CLKPR=(1<<CLKPCE);
CLKPR=(1<<CLKPS1)|(1<<CLKPS0);
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=T 
PORTA=0xFE;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=0 State0=P 
PORTB=0xFD;
DDRB=0x02;

// Timer/Counter 0 initialization
// Clock source: System Clock/1024
// Clock value: ~1kHz (8MHz/8/1024)
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=(1<<WGM01);
TCCR0B=(1<<CS02)|(1<<CS00);
TCNT0=0x00;
OCR0A=244;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Timer1 Overflow Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1=0x00;
OCR1A=0x00;
OCR1B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-15: Off
MCUCR=0x00;
GIMSK=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=(1<<OCIE0A);

// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: switch Off
ACSR=(1<<ACD);
ADCSRB=0x00;
DIDR0=0x00;

// ADC initialization
// ADC Clock frequency: 62,500 kHz
// ADC Auto Trigger Source: ADC Stopped
// Only the 8 most significant bits of
// the AD conversion result are used
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0=(1<<ADC3D)|(11<<ADC2D)|(11<<ADC1D);
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(ADPS0);
ADCSRB&=0xEF;
ADCSRB|=(1<<ADLAR);

// Global enable interrupts
#asm("sei")

while (1)
      {
            if(timer0_ctc)
            {
                timer0_ctc=0;
                light=read_adc(LIGHT_SENSOR);
                switch(device_state)
                {
                    case night:
                    if(light<DAY) 
                    {
                        device_state=morning;
                        work_cycles=0;
                    }
                    //w nocy, lub straszak odoony do ciemnego - nie wibruj
                    break;
                    
                    case morning:
                    WIBR=!WIBR;
                    work_cycles++;
                    if(work_cycles>240) 
                    {
                        device_state=day;
                        work_delay=0;
                    }
                    //o poranku wibruj intensywnie przez kilka minut
                    break;
                    
                    case day:
                    work_delay++;
                    WIBR=0;
                    if(work_delay>60)
                    {
                        work_delay=0;
                        WIBR=1;
                    }
                    if(light>NIGHT) {device_state=night;}
                    //w dzie wibruj raz na 15sek.
                    break;
                }
            }
      }
}
